// ignore: file_names
typedef OnInvited = void Function(InviteParams params);

typedef OnReject = void Function(RejectParams params);

typedef OnNoResp = void Function(NoRespParams params);

typedef OnLineBusy = void Function(OnLineBusyParams params);

typedef OnCallingCancel = void Function();

typedef OnCallingTimeout = void Function(OnCallingTimeoutParams params);

typedef OnCallEnd = void Function();

typedef OnUserVideoAvailable = void Function(OnUserVideoAvailableParams params);

typedef OnUserAudioAvailable = void Function(OnUserAudioAvailableParams params);

typedef OnKickedOffline = void Function();

typedef OnEnterRoom = void Function(int time);

typedef OnUserEnter = void Function(OnUserEnterParams params);

typedef OnUserLeave = void Function(OnUserLeaveParams params);

typedef OnGroupCallInviteeListUpdate = void Function(
    OnGroupCallInviteeListUpdateParams params);

typedef OnError = void Function(OnErrorParams params);

typedef OnWarning = void Function(OnWarningPrams params);

typedef OnUserVoiceVolume = void Function(dynamic params);

class InviteParams {
  String sponsor;
  List<String> userIDList;
  bool isFromGroup;
  String? callType;
  String groupID;

  InviteParams(
      {this.sponsor = '',
      this.callType,
      this.isFromGroup = false,
      this.groupID = '',
      required this.userIDList});
}

class RejectParams {
  String userID;

  RejectParams({this.userID = ''});
}

class NoRespParams {
  String userID;
  NoRespParams({this.userID = ''});
}

class OnLineBusyParams {
  String userID;
  OnLineBusyParams({this.userID = ''});
}

class OnUserVideoAvailableParams {
  String userID;
  bool available;

  OnUserVideoAvailableParams({this.userID = "", this.available = false});
}

class OnUserAudioAvailableParams {
  String userID;
  bool available;

  OnUserAudioAvailableParams({this.userID = "", this.available = false});
}

class OnUserEnterParams {
  String userID;

  OnUserEnterParams({this.userID = ""});
}

class OnUserLeaveParams {
  String userID;
  int reason;

  OnUserLeaveParams({this.userID = "", this.reason = 0});
}

class OnGroupCallInviteeListUpdateParams {
  List<String> userIDList;

  OnGroupCallInviteeListUpdateParams({required this.userIDList});
}

class OnErrorParams {
  int errCode;
  String errMsg;
  String extraInfo;

  OnErrorParams(
      {required this.errCode, required this.errMsg, required this.extraInfo});
}

class OnWarningPrams {
  int warningCode;
  String warningMsg;
  String extraInfo;

  OnWarningPrams(
      {required this.warningCode,
      required this.warningMsg,
      required this.extraInfo});
}

class OnCallingTimeoutParams {
  List<String> userIDList;

  OnCallingTimeoutParams({required this.userIDList});
}
