import 'dart:async';

import 'package:flutter/material.dart';
import 'package:tim_ui_kit_calling_plugin/view/c2c/utils.dart';

class CallingTime extends StatefulWidget {
  final DateTime startTime;

  const CallingTime({Key? key, required this.startTime}) : super(key: key);

  @override
  State<StatefulWidget> createState() => _CallingTimeState();
}

class _CallingTimeState extends State<CallingTime> {
  String callingTime = "00:00";
  late Timer timer;

  _startCalling() {
    timer = Timer.periodic(const Duration(seconds: 1), (Timer timer) {
      DateTime now = DateTime.now();
      Duration duration = now.difference(widget.startTime);
      setState(() {
        callingTime = TRTCC2cUtils.getDurationTimeString(duration);
      });
    });
  }

  @override
  void initState() {
    super.initState();
    _startCalling();
  }

  @override
  void dispose() {
    super.dispose();
    timer.cancel();
  }

  @override
  Widget build(BuildContext context) {
    return Text(
      callingTime,
      style: const TextStyle(color: Colors.white),
    );
  }
}
